//lit l'animation-zoom mandzoom.ani cre par mandzoo2.c
//09/98 by Doodle
#include <conio.h>
#include <dos.h> //pr emit et outportb
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <iostream.h>

#define MAXX 128 				//points 
#define MAXY 96 				//calculer

#define MAXXECR 192			//taille de la
#define MAXYECR 144   		//fentre  l'cran

typedef unsigned long dword;
typedef unsigned int word;
typedef unsigned char byte;

void Init();
void putpixel(word x,word y,word c);
void WaitRetrace();
void setpalette(int offset);
void closegraph();
void affiche(double zoom);
int sq(int in){return (in*in);}

byte ecr[MAXX][MAXY];
FILE *f;

void main()
{
   int i,j,nbetap=8;
	double zoom=1.5,zoommult=pow(2.,1./(double)(nbetap));

	Init();
   f=fopen("mandzoom.ani","rb");
   fseek(f,SEEK_SET,0);
   for(i=0;!(kbhit());i++){
      zoom=1.5;
      if(fread(ecr,1,MAXX*MAXY,f)){
	   	for(j=0;j<nbetap && !(kbhit());j++){
         	affiche(zoom);
 		     	zoom*=zoommult;
         }
      }else break;
   }
   getch();
	closegraph();
}

void Init()
{ 	__emit__(0xb8,0x13,0x00,0xcd,0x10); //320*200*256
	setpalette(0);
}

void closegraph()
{	__emit__(0xb8,0x03,0x00,0xcd,0x10); //retour au mode texte
}

void setpalette(int offset)
{	byte r,g,b;
	for(int i=0;i<256;i++){
		r=63/(sq((i+214)%256-128)/5000.+1.);
		g=63/(sq((i+129)%256-128)/5000.+1.);
		b=63/(sq((i+44)%256-128)/5000.+1.);
		outportb(0x3c8,i+offset);		outportb(0x3c9,r);
		outportb(0x3c9,g);      		outportb(0x3c9,b);
	}
	outportb(0x3c8,offset);   	outportb(0x3c9,0);
	outportb(0x3c9,0);      	outportb(0x3c9,0);
}

void putpixel(word x,word y,word c)
{	char far *Screen;
	Screen=(char far *)MK_FP(0xa000,0x0000);
	Screen[(dword)y*320ul+(dword)x]=(byte)c;
}

void WaitRetrace()
{
	asm mov dx,3DAh;
	l1:
	asm{in al,dx
		and al,08h
		jnz l1}
	l2:
	asm{in al,dx
		and al,08h
		jz  l2}
}

void affiche(double zoom)
{ 	int i,j;
   double itab,jtab,incr=1/zoom;
   itab=-((double)(MAXXECR>>1))/zoom+(MAXX>>1);
   WaitRetrace();
   for(i=0;i<MAXXECR;i++){
      if(itab<MAXX && itab>=0){
         jtab=-((double)(MAXYECR>>1))/zoom+(MAXY>>1);
   		for(j=0;j<MAXYECR;j++){
     	      //affichage du pixel s'il correspond  un lment existant
           	if(jtab<MAXY && jtab>=0)
					putpixel(i,j,ecr[(int)itab][(int)jtab]);
            jtab+=incr;
		}	}
      itab+=incr;
}	}

